<?php
/*
  Plugin Name: Goserve Review Widget
  Plugin URI: http://www.goserve.co/widget
  Description: The most complete plugin to build social proof, trust and credibility with potential customers by showcasing your reviews on your website.
  Version: 1.0
  Author: Goserve
  License: GPL2
 */


if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

if (defined("WP_INSTALLING") && WP_INSTALLING) {
    return;
}

if ( ! defined( 'GRW_TOKEN__' ) ) {
    define( 'GRW_TOKEN__', '0f39a9d1dd2f17fe3198fc88922c4a40e9847096a70ed124' );
}
if ( ! defined( 'GRW_URL_BASE__' ) ) {
    define( 'GRW_URL_BASE__', 'http://app.goserve.co/api/v1/' );
}
if ( ! defined( 'GRW_DEBUG__' ) ) {
    define( 'GRW_DEBUG__', true );
}

/**
 * This function use to add eatabout widget page menu in admin
 */
function grw_activation_redirect($plugin) {
    if ($plugin == plugin_basename(__FILE__)) {
        exit(wp_redirect(admin_url('admin.php?page=widget-configuration')));
    }
}

add_action('activated_plugin', 'grw_activation_redirect');

function grw_widget_conf_page() {
    add_menu_page(
            'Goserve Review Widget', // page title
            'Goserve Review Widget', // menu title
            'manage_options', // capability
            'widget-configuration', // menu slug
            'grw_widget_conf_page_render' // callback function
    );
}

add_action('admin_menu', 'grw_widget_conf_page');

function grw_update_option( $id, $value ) {
    update_option( 'grw_' . $id, $value );
}

function grw_get_option( $id ) {
    return get_option( 'grw_' . $id );
}

/**
 * This function use to add registration page in admin
 * & check key is valid or not
 */
function grw_widget_conf_page_render() {
    $nonce  = wp_create_nonce( 'arw' );
    ?>
    <style>
        .notice.social{
            background: green;
            color: #fff;
        }
        .notice.social p{
            font-size: 15px;
        }
    </style>
    <div class="wrap">
        <h1 class="add-new-user">Goserve Review Widget Configuration</h1>
        <form name="widget_confi_form" action="" method="post" id="createuser" class="validate">
            <div class="notice notice-warning is-dismissible social" style="display:none;">
                <p id="show_social">Add your review URLs below and hit submit to populate your review widget!</p>
            </div>
            <div class="notice notice-warning is-dismissible response_div" style="display:none;">
                <p id="response_msg"></p>
            </div>

            <table class="form-table">
                <tbody>
                    <tr class="form-field form-required">
                        <th scope="row"><label for="user_login">Site name <span class="description">(required)</span></label></th>
                        <td>
                            <input name="company_name" type="text" id="company_name" value="<?php
                            if (!empty(grw_get_option('company_name'))) {
                                echo grw_get_option('company_name');
                            } else {
                                echo bloginfo('name');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60"><br />
                            <span id="company_name_error" style="color:red;"></span>
                        </td>
                    </tr>
                    <tr class="form-field form-required" style="display:none;">
                        <th scope="row"><label for="user_login">Subdomain <span class="description">(required)</span></label></th>
                        <td>
                            <input name="subdomain" type="text" id="subdomain" value="<?php
                            if (!empty(grw_get_option('subdomain'))) {
                                echo grw_get_option('subdomain');
                            } else {
                                echo bloginfo('name');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60"><br />
                            <span id="subdomain_error" style="color:red;"></span>
                        </td>
                    </tr>
                    <tr class="form-field form-required">
                        <th scope="row"><label for="user_login">Email <span class="description">(required)</span></label></th>
                        <td>
                            <input name="email" type="email" id="email" value="<?php
                            if (!empty(grw_get_option('email'))) {
                                echo grw_get_option('email');
                            } else {
                                echo bloginfo('admin_email');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60"><br />
                            <span id="email_error" style="color:red;"></span>
                        </td>
                    </tr>
                    <tr class="form-field form-required">
                        <th scope="row"><label for="user_login">URL <span class="description">(required)</span></label></th>
                        <td>
                            <input name="url" type="url" id="url" value="<?php
                            if (!empty(grw_get_option('company_url'))) {
                                echo grw_get_option('company_url');
                            } else {
                                echo bloginfo('url');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60"><br />
                            <span id="url_error" style="color:red;"></span>
                        </td>
                    </tr>
                    <tr>
                        For support please contact us at <a href="mailto:hello@goserve.co?Subject=WP%20plugin">hello@goserve.co.</a>
                    </tr>
                    <tr>
                        <th colspan="2" scope="row">
                            <h2 for="user_login">Review URLs</h2>
                            <span class="description">(Note: Please fill at least one review URL)</span>
                        </th>
                    </tr>
                    <tr class="form-field form-required">
                        <th scope="row"><label for="user_login">Google Place ID</span></label></th>
                        <td>
                            <input name="google_url" type="url" id="google_url" value="<?php
                            if (!empty(grw_get_option('google_url'))) {
                                echo grw_get_option('google_url');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60" placeholder="eg: ChIJDUCVW_ZawokRHmqcLpdhsaY"><br />

                            <span id="google_url_error" style="color:red;"></span><br/>
                            <a href="https://developers.google.com/places/place-id" target="_blank">Find your Google Place ID</a>
                        </td>
                    </tr>
                    <tr class="form-field form-required">
                        <th scope="row"><label for="user_login">Facebook URL</label></th>
                        <td>
                            <input name="fb_url" type="url" id="fb_url" value="<?php
                            if (!empty(grw_get_option('fb_url'))) {
                                echo grw_get_option('fb_url');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60" placeholder="eg: https://www.facebook.com/bullandragon"><br />
                            <span id="fb_url_error" style="color:red;"></span>
                        </td>
                    </tr>
                    <tr class="form-field form-required">
                        <th scope="row"><label for="user_login">Yelp URL</label></th>
                        <td>
                            <input name="yelp_url" type="url" id="yelp_url" value="<?php
                            if (!empty(grw_get_option('yelp_url'))) {
                                echo grw_get_option('yelp_url');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60" placeholder="eg: https://www.yelp.com/biz/naturally-delicious-brooklyn"><br />
                            <span id="yelp_url_error" style="color:red;"></span>
                        </td>
                    </tr>
                    <tr class="form-field form-required">
                        <th scope="row"><label for="user_login">Knot URL</label></th>
                        <td>
                            <input name="knot_url" type="url" id="knot_url" value="<?php
                            if (!empty(grw_get_option('knot_url'))) {
                                echo grw_get_option('knot_url');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60" placeholder="eg: https://www.theknot.com/marketplace/the-liberty-warehouse-brooklyn-ny-371369"><br />
                            <span id="knot_url_error" style="color:red;"></span>
                        </td>
                    </tr>
                    <tr class="form-field form-required">
                        <th scope="row"><label for="user_login">Thumbtack URL</label></th>
                        <td>
                            <input name="thumbtack_url" type="url" id="thumbtack_url" value="<?php
                            if (!empty(grw_get_option('thumbtack_url'))) {
                                echo grw_get_option('thumbtack_url');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60" placeholder="eg: https://www.thumbtack.com/ca/san-diego/personal-chefs/culinary-services"><br />
                            <span id="thumbtack_url_error" style="color:red;"></span>
                        </td>
                    </tr>
                    <tr class="form-field form-required">
                        <th scope="row"><label for="user_login">TripAdvisor URL</label></th>
                        <td>
                            <input name="tripadvisor_url" type="url" id="tripadvisor_url" value="<?php
                            if (!empty(grw_get_option('tripadvisor_url'))) {
                                echo grw_get_option('tripadvisor_url');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60" placeholder="eg: https://www.tripadvisor.com/Restaurant_Review-g187147-d11752078-Reviews-Jean_Yves_of_Chef_Jean_Yves_Table-Paris_Ile_de_France.html"><br />
                            <span id="tripadvisor_url_error" style="color:red;"></span>
                        </td>
                    </tr>
                    <tr class="form-field form-required">
                        <th scope="row"><label for="user_login">Trustpilot URL</label></th>
                        <td>
                            <input name="trustpilot_url" type="url" id="trustpilot_url" value="<?php
                            if (!empty(grw_get_option('trustpilot_url'))) {
                                echo grw_get_option('trustpilot_url');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60" placeholder="eg: https://www.trustpilot.com/review/luggagefree.com"><br />
                            <span id="trustpilot_url_error" style="color:red;"></span>
                        </td>
                    </tr>
                    <tr class="form-field form-required">
                        <th scope="row"><label for="user_login">WeddingWire URL</label></th>
                        <td>
                            <input name="weddingwire_url" type="url" id="weddingwire_url" value="<?php
                            if (!empty(grw_get_option('weddingwire_url'))) {
                                echo grw_get_option('weddingwire_url');
                            }
                            ?>" aria-required="true" autocapitalize="none" autocorrect="off" maxlength="60" placeholder="eg: https://www.weddingwire.com/biz/naturally-delicious-brooklyn/ce3efc639350effb.html"><br />
                            <span id="weddingwire_url_error" style="color:red;"></span>
                        </td>
                    </tr>
                </tbody>
            </table>
            <p class="submit" style="width: 25%">
                <input type="button" name="sub_btn" id="sub_btn" class="button button-primary" value="Submit">
                <span id="grw-spinner" class="spinner" aria-hidden="true"></span>
            </p>
        </form>
    </div>
    <script>
        jQuery(document).ready(function() {

            function showSpinner() {
               jQuery('#grw-spinner').css('visibility', 'visible').attr('aria-hidden', 'false').show();
            }

            function hideSpinner() {
                jQuery('#grw-spinner').css('visibility', 'hidden').attr('aria-hidden', 'true').hide();
            }

            var google_url = jQuery('#google_url').val();
            var fb_url = jQuery('#fb_url').val();
            var yelp_url = jQuery('#yelp_url').val();
            var knot_url = jQuery('#knot_url').val();
            var thumbtack_url = jQuery('#thumbtack_url').val();
            var tripadvisor_url = jQuery('#tripadvisor_url').val();
            var trustpilot_url = jQuery('#trustpilot_url').val();
            var weddingwire_url = jQuery('#weddingwire_url').val();
            if (google_url == '' && fb_url == '' && yelp_url == '' && knot_url == '' && thumbtack_url == '' && tripadvisor_url == '' && trustpilot_url == '' && weddingwire_url == '') {
                jQuery('.social.notice').show();
            }
            jQuery('#sub_btn').click(function() {
                var error = 0;
                jQuery('.response_div').css('display', 'none');
                jQuery('#response_msg').html('');
                jQuery('#company_name_error').html('');
                jQuery('#subdomain_error').html('');
                jQuery('#email_error').html('');
                jQuery('#url_error').html('');
                jQuery('#google_url_error').html('');
                jQuery('#fb_url_error').html('');
                jQuery('#yelp_url_error').html('');
                jQuery('#knot_url_error').html('');
                jQuery('#thumbtack_url_error').html('');
                jQuery('#tripadvisor_url_error').html('');
                jQuery('#trustpilot_url_error').html('');
                jQuery('#weddingwire_url_error').html('');

                var company_name = jQuery('#company_name').val();
                var subdomain = jQuery('#subdomain').val();
                var email = jQuery('#email').val();
                var url = jQuery('#url').val();
                var google_url = jQuery('#google_url').val();
                var fb_url = jQuery('#fb_url').val();
                var yelp_url = jQuery('#yelp_url').val();
                var knot_url = jQuery('#knot_url').val();
                var thumbtack_url = jQuery('#thumbtack_url').val();
                var tripadvisor_url = jQuery('#tripadvisor_url').val();
                var trustpilot_url = jQuery('#trustpilot_url').val();
                var weddingwire_url = jQuery('#weddingwire_url').val();

                if (company_name == '') {
                    jQuery('#company_name_error').html('Please enter company name');
                    error = 1;
                }
                if (subdomain == '') {
                    jQuery('#subdomain_error').html('Please enter subdomain');
                    error = 1;
                }
                if (email == '') {
                    jQuery('#email_error').html('Please enter email');
                    error = 1;
                } else {
                    var filter = /^[\w\-\.\+]+\@[a-zA-Z0-9\.\-]+\.[a-zA-z0-9]{2,4}$/;
                    if (!filter.test(email)) {
                        jQuery('#email_error').html('Please enter valid email');
                        error = 1;
                    }
                }
                var urlregex = new RegExp("^(http:\/\/www.|https:\/\/www.|ftp:\/\/www.|www.){1}([0-9A-Za-z]+\.)");
                if (url == '') {
                    jQuery('#url_error').html('Please enter URL');
                    error = 1;
                } else {
                    if (!urlregex.test(url)) {
                        jQuery('#url_error').html('Please enter valid URL');
                        error = 1;
                    }
                }
                if (google_url == '' && fb_url == '' && yelp_url == '' && knot_url == '' && thumbtack_url == '' && tripadvisor_url == '' && trustpilot_url == '' && weddingwire_url == '') {
                    jQuery('#google_url_error').html('Please enter URL');
                    jQuery('#fb_url_error').html('Please enter URL');
                    jQuery('#yelp_url_error').html('Please enter URL');
                    jQuery('#knot_url_error').html('Please enter URL');
                    jQuery('#thumbtack_url_error').html('Please enter URL');
                    jQuery('#tripadvisor_url_error').html('Please enter URL');
                    jQuery('#trustpilot_url_error').html('Please enter URL');
                    jQuery('#weddingwire_url_error').html('Please enter URL');
                    error = 1;
                } else {
                    if (fb_url != '') {
                        if (!urlregex.test(fb_url)) {
                            jQuery('#fb_url_error').html('Please enter valid URL');
                            error = 1;
                        }
                    }
                    if (yelp_url != '') {
                        if (!urlregex.test(yelp_url)) {
                            jQuery('#yelp_url_error').html('Please enter valid URL');
                            error = 1;
                        }
                    }
                    if (thumbtack_url != '') {
                        if (!urlregex.test(thumbtack_url)) {
                            jQuery('#thumbtack_url_error').html('Please enter valid URL');
                            error = 1;
                        }
                    }
                    if (tripadvisor_url != '') {
                        if (!urlregex.test(tripadvisor_url)) {
                            jQuery('#tripadvisor_url_error').html('Please enter valid URL');
                            error = 1;
                        }
                    }
                    if (trustpilot_url != '') {
                        if (!urlregex.test(trustpilot_url)) {
                            jQuery('#trustpilot_url_error').html('Please enter valid URL');
                            error = 1;
                        }
                    }
                    if (weddingwire_url != '') {
                        if (!urlregex.test(weddingwire_url)) {
                            jQuery('#weddingwire_url_error').html('Please enter valid URL');
                            error = 1;
                        }
                    }
                }




                if (error == 1) {
                    jQuery('.response_div').css('display', 'block');
                    jQuery('#response_msg').html("Please enter required fields.");
                    jQuery("html, body").animate({scrollTop: 0}, "slow");
                    return false;
                } else {
                    showSpinner();
                    jQuery.ajax({
                        type: 'POST',
                        url: "<?php echo admin_url( 'admin-ajax.php' ); ?>",
                        dataType: "json",
                        data: {action: 'arw', nonce: '<?php echo $nonce;?>', company_name: company_name, subdomain: subdomain, email: email, url: url, google_url: google_url, fb_url: fb_url, yelp_url: yelp_url, knot_url: knot_url, thumbtack_url: thumbtack_url, tripadvisor_url: tripadvisor_url, trustpilot_url: trustpilot_url, weddingwire_url: weddingwire_url},
                        //cache: false, 
                        success: function(data) {
                            jQuery("html, body").animate({scrollTop: 0}, "slow");
                            jQuery('.response_div').css('display', 'block');
                            jQuery('#response_msg').html(data['response_msg']);
                            hideSpinner();
                        }
                    });
                }
            });

        });
    </script>
    <?php
}

    function grw_ajax_handler() {
        check_ajax_referer( 'arw', 'nonce' );

        if ( ! current_user_can( 'manage_options' ) ) {
            wp_die();
        }

        $google_url = '';
        $fb_url = '';
        $yelp_url = '';
        $knot_url = '';
        $thumbtack_url = '';
        $tripadvisor_url = '';
        $trustpilot_url = '';
        $weddingwire_url = '';

        $company_name = sanitize_text_field($_POST['company_name']);
        $email = sanitize_email($_POST['email']);
        if ( ! filter_var( $email, FILTER_VALIDATE_EMAIL ) ) {
            echo json_encode(array('response_msg' => $email . ' is an invalid email' ));
            wp_die();
        }

        $url = grw_check_url(sanitize_text_field($_POST['url']));
        if (!empty($_POST['fb_url']))
            $fb_url = grw_check_url(sanitize_text_field($_POST['fb_url']));
        if (!empty($_POST['yelp_url']))
            $yelp_url = grw_check_url(sanitize_text_field($_POST['yelp_url']));
        if (!empty($_POST['knot_url']))
            $knot_url = grw_check_url(sanitize_text_field($_POST['knot_url']));
        if (!empty($_POST['thumbtack_url']))
            $thumbtack_url = grw_check_url(sanitize_text_field($_POST['thumbtack_url']));
        if (!empty($_POST['tripadvisor_url']))
            $tripadvisor_url = grw_check_url(sanitize_text_field($_POST['tripadvisor_url']));
        if (!empty($_POST['trustpilot_url']))
            $trustpilot_url = grw_check_url(sanitize_text_field($_POST['trustpilot_url']));
        if (!empty($_POST['weddingwire_url']))
            $weddingwire_url = grw_check_url(sanitize_text_field($_POST['weddingwire_url']));

        //register company
        $args = array(
            'method' => 'POST',
            'timeout' => 45,
            'redirection' => 5,
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => array('X-Spree-Token' => GRW_TOKEN__),
            'body' => array('company' =>
                array(
                    'name' => $company_name,
                    'rsvp_subdomain' => grw_get_option('subdomain'),
                    'email' => $email,
                    'url' => $url
                )
            ),
            'cookies' => array()
        );

        grw_log( "Request to api " . GRW_URL_BASE__ . 'process_company.json' . ": " . print_r($args,true));

        $response = wp_remote_post(GRW_URL_BASE__ . 'process_company.json', $args);
        grw_log( "Response from api: " . print_r($response,true));
        $api_response = json_decode(wp_remote_retrieve_body($response), true);

        if ($api_response['status'] == 200) {
            $sub_domain = $api_response['company']['subdomain'];
            $source_url = $api_response['company']['url'];
            grw_update_option('company_name', $company_name);
            if (!empty($source_url))
                grw_update_option('source_url', $source_url);
            if (!empty($sub_domain))
                grw_update_option('subdomain', $sub_domain);
            grw_update_option('email', $email);
            grw_update_option('company_url', $url);
            grw_update_option('google_url', $google_url);
            grw_update_option('fb_url', $fb_url);
            grw_update_option('yelp_url', $yelp_url);
            grw_update_option('knot_url', $knot_url);
            grw_update_option('thumbtack_url', $thumbtack_url);
            grw_update_option('tripadvisor_url', $tripadvisor_url);
            grw_update_option('trustpilot_url', $trustpilot_url);
            grw_update_option('weddingwire_url', $weddingwire_url);
            //send request to get reviews from sources
            if ($google_url != '') {
                $args1 = array(
                    'method' => 'POST',
                    'timeout' => 45,
                    'redirection' => 5,
                    'httpversion' => '1.0',
                    'blocking' => true,
                    'headers' => array('X-Spree-Token' => GRW_TOKEN__),
                    'body' => array(
                        'subdomain' => grw_get_option('subdomain'),
                        'source' => array(
                            'source_name' => 'google',
                            'source_url' => $google_url
                        )
                    ),
                    'cookies' => array()
                );

                grw_log( "Request to api " . GRW_URL_BASE__ . 'review_sources.json' . ": " . print_r($args1,true));
                $response1 = wp_remote_post(GRW_URL_BASE__ . 'review_sources.json', $args1);
                grw_log( "Response from api: " . print_r($response1,true));
                $api_response1 = json_decode(wp_remote_retrieve_body($response1), true);

            }
            if ($fb_url != '') {
                $args1 = array(
                    'method' => 'POST',
                    'timeout' => 45,
                    'redirection' => 5,
                    'httpversion' => '1.0',
                    'blocking' => true,
                    'headers' => array('X-Spree-Token' => GRW_TOKEN__),
                    'body' => array(
                        'subdomain' => grw_get_option('subdomain'),
                        'source' => array(
                            'source_name' => 'facebook',
                            'source_url' => $fb_url
                        )
                    ),
                    'cookies' => array()
                );
                grw_log( "Request to api " . GRW_URL_BASE__ . 'review_sources.json' . ": " . print_r($args1,true));
                $response1 = wp_remote_post(GRW_URL_BASE__ . 'review_sources.json', $args1);
                grw_log( "Response from api: " . print_r($response1,true));
                $api_response1 = json_decode(wp_remote_retrieve_body($response1), true);
            }
            if ($yelp_url != '') {
                $args1 = array(
                    'method' => 'POST',
                    'timeout' => 45,
                    'redirection' => 5,
                    'httpversion' => '1.0',
                    'blocking' => true,
                    'headers' => array('X-Spree-Token' => GRW_TOKEN__),
                    'body' => array(
                        'subdomain' => grw_get_option('subdomain'),
                        'source' => array(
                            'source_name' => 'yelp',
                            'source_url' => $yelp_url
                        )
                    ),
                    'cookies' => array()
                );
                grw_log( "Request to api " . GRW_URL_BASE__ . 'review_sources.json' . ": " . print_r($args1,true));
                $response1 = wp_remote_post(GRW_URL_BASE__ . 'review_sources.json', $args1);
                grw_log( "Response from api: " . print_r($response1,true));
                $api_response1 = json_decode(wp_remote_retrieve_body($response1), true);
            }
            if ($knot_url != '') {
                $args1 = array(
                    'method' => 'POST',
                    'timeout' => 45,
                    'redirection' => 5,
                    'httpversion' => '1.0',
                    'blocking' => true,
                    'headers' => array('X-Spree-Token' => GRW_TOKEN__),
                    'body' => array(
                        'subdomain' => grw_get_option('subdomain'),
                        'source' => array(
                            'source_name' => 'the knot',
                            'source_url' => $knot_url
                        )
                    ),
                    'cookies' => array()
                );
                grw_log( "Request to api " . GRW_URL_BASE__ . 'review_sources.json' . ": " . print_r($args1,true));
                $response1 = wp_remote_post(GRW_URL_BASE__ . 'review_sources.json', $args1);
                grw_log( "Response from api: " . print_r($response1,true));
                $api_response1 = json_decode(wp_remote_retrieve_body($response1), true);
            }
            if ($thumbtack_url != '') {
                $args1 = array(
                    'method' => 'POST',
                    'timeout' => 45,
                    'redirection' => 5,
                    'httpversion' => '1.0',
                    'blocking' => true,
                    'headers' => array('X-Spree-Token' => GRW_TOKEN__),
                    'body' => array(
                        'subdomain' => grw_get_option('subdomain'),
                        'source' => array(
                            'source_name' => 'thumbtack',
                            'source_url' => $thumbtack_url
                        )
                    ),
                    'cookies' => array()
                );
                grw_log( "Request to api " . GRW_URL_BASE__ . 'review_sources.json' . ": " . print_r($args1,true));
                $response1 = wp_remote_post(GRW_URL_BASE__ . 'review_sources.json', $args1);
                grw_log( "Response from api: " . print_r($response1,true));
                $api_response1 = json_decode(wp_remote_retrieve_body($response1), true);
                if ($api_response1['status'] == 200)
                    $success .= $api_response1['message'];
                else
                    $error .= $api_response1['message'];
            }
            if ($tripadvisor_url != '') {
                $args1 = array(
                    'method' => 'POST',
                    'timeout' => 45,
                    'redirection' => 5,
                    'httpversion' => '1.0',
                    'blocking' => true,
                    'headers' => array('X-Spree-Token' => GRW_TOKEN__),
                    'body' => array(
                        'subdomain' => grw_get_option('subdomain'),
                        'source' => array(
                            'source_name' => 'tripadvisor',
                            'source_url' => $tripadvisor_url
                        )
                    ),
                    'cookies' => array()
                );
                grw_log( "Request to api " . GRW_URL_BASE__ . 'review_sources.json' . ": " . print_r($args1,true));
                $response1 = wp_remote_post(GRW_URL_BASE__ . 'review_sources.json', $args1);
                grw_log( "Response from api: " . print_r($response1,true));
                $api_response1 = json_decode(wp_remote_retrieve_body($response1), true);
            }
            if ($trustpilot_url != '') {
                $args1 = array(
                    'method' => 'POST',
                    'timeout' => 45,
                    'redirection' => 5,
                    'httpversion' => '1.0',
                    'blocking' => true,
                    'headers' => array('X-Spree-Token' => GRW_TOKEN__),
                    'body' => array(
                        'subdomain' => grw_get_option('subdomain'),
                        'source' => array(
                            'source_name' => 'trustpilot',
                            'source_url' => $trustpilot_url
                        )
                    ),
                    'cookies' => array()
                );
                grw_log( "Request to api " . GRW_URL_BASE__ . 'review_sources.json' . ": " . print_r($args1,true));
                $response1 = wp_remote_post(GRW_URL_BASE__ . 'review_sources.json', $args1);
                grw_log( "Response from api: " . print_r($response1,true));
                $api_response1 = json_decode(wp_remote_retrieve_body($response1), true);
            }
            if ($weddingwire_url != '') {
                $args1 = array(
                    'method' => 'POST',
                    'timeout' => 45,
                    'redirection' => 5,
                    'httpversion' => '1.0',
                    'blocking' => true,
                    'headers' => array('X-Spree-Token' => GRW_TOKEN__),
                    'body' => array(
                        'subdomain' => grw_get_option('subdomain'),
                        'source' => array(
                            'source_name' => 'weddingwire',
                            'source_url' => $weddingwire_url
                        )
                    ),
                    'cookies' => array()
                );
                grw_log( "Request to api " . GRW_URL_BASE__ . 'review_sources.json' . ": " . print_r($args1,true));
                $response1 = wp_remote_post(GRW_URL_BASE__ . 'review_sources.json', $args1);
                grw_log( "Response from api: " . print_r($response1,true));
                $api_response1 = json_decode(wp_remote_retrieve_body($response1), true);
            }
            if ($api_response1['status'] == 200)
                $response_msg = $api_response1['message'];
            else
                $response_msg = $api_response1['message'];
        }else {
            $response_msg = $api_response['error'];
        }

        if($response_msg == 'Source has been successfully updated'){
            $response_msg = 'Information updated successfully and your widget is activated. Please visit your Widgets page to set it up!';
        }
        echo json_encode(array('response_msg' => esc_html( $response_msg ) ));
        wp_die();

    }
    add_action( 'wp_ajax_arw', 'grw_ajax_handler' );

    function grw_clean($string) {
        $string = strtolower($string);
        $string = str_replace(' ', '', $string); // Replaces all spaces with hyphens.
        return preg_replace('/[^A-Za-z0-9\-]/', '', $string); // Removes special chars.
    }

    function grw_check_url( $url ) {
        if ( ! filter_var( $url, FILTER_VALIDATE_URL ) ) {
            echo json_encode(array('response_msg' => $url . ' is an invalid URL' ));
            wp_die();
        }
        return esc_url( $url );
    }

    function grw_log( $msg ) {
        if ( ! GRW_DEBUG__ ) {
            return;
        }
        @mkdir( __DIR__. "/tmp" );
        file_put_contents( __DIR__. "/tmp/log.log", date("F j, Y H:i:s", current_time("timestamp")) . " - " . $msg."\n", FILE_APPEND);
    }

// Register and load the widget
function grw_load_widget() {
    if (!empty(grw_get_option('source_url'))) {
        register_widget('grw_widget');
    }
}

add_action('widgets_init', 'grw_load_widget');

// Creating the widget 
class GRW_Widget extends WP_Widget {

    function __construct() {
        parent::__construct(
                'grw_widget', 'Goserve Review Widget', array('description' => 'Goserve Review Widget')
        );
    }

    // Creating widget front-end
    public function widget($args, $instance) {
        $font = apply_filters('widget_title', $instance['font']);
        $header_text_color = apply_filters('widget_title', $instance['header_text_color']);
        $schedular_text_color = apply_filters('widget_title', $instance['schedular_text_color']);
        $body_background = apply_filters('widget_title', $instance['body_background']);
        $schedular_background = apply_filters('widget_title', $instance['schedular_background']);
        $star_background = apply_filters('widget_title', $instance['star_background']);
        $source_name = apply_filters('widget_title', $instance['source_name']);
        $iframe_height = apply_filters('widget_title', $instance['iframe_height']);
        $iframe_width = apply_filters('widget_title', $instance['iframe_width']);



        if (!empty(grw_get_option('source_url'))) {
            if ((strpos($iframe_width, 'px') == false) && (strpos($iframe_width, '%') == false)) {
                $iframe_width = $iframe_width . 'px';
            }
            if ((strpos($iframe_height, 'px') == false) && (strpos($iframe_height, '%') == false)) {
                $iframe_height = $iframe_height . 'px';
            }
            ?>
            <iframe src="<?php echo 'http://' . grw_get_option('source_url') . '/custom_widget?font=' . $font . '&header_text_color=' . $header_text_color . '&schedular_text_color=' . $schedular_text_color . 'body_background=' . $body_background . '&schedular_background=' . $schedular_background . '&star_background=' . $star_background; ?>" style="background:#fff; width:<?php echo $iframe_width; ?>; height:<?php echo $iframe_height; ?>;" frameborder="0"></iframe>
            <?php
        }
    }

    // Widget Backend 
    public function form($instance) {
        if (isset($instance['font'])) {
            $font = $instance['font'];
        } else {
            $font = __('Font Name', 'executive_widget_domain');
        }
        if (isset($instance['header_text_color'])) {
            $header_text_color = $instance['header_text_color'];
        } else {
            $header_text_color = __('FFFFFF', 'executive_widget_domain');
        }
        if (isset($instance['schedular_text_color'])) {
            $schedular_text_color = $instance['schedular_text_color'];
        } else {
            $schedular_text_color = __('FFFFFF', 'executive_widget_domain');
        }
        if (isset($instance['body_background'])) {
            $body_background = $instance['body_background'];
        } else {
            $body_background = __('FFFFFF', 'executive_widget_domain');
        }
        if (isset($instance['schedular_background'])) {
            $schedular_background = $instance['schedular_background'];
        } else {
            $schedular_background = __('FFFFFF', 'executive_widget_domain');
        }
        if (isset($instance['star_background'])) {
            $star_background = $instance['star_background'];
        } else {
            $star_background = __('FFFFFF', 'executive_widget_domain');
        }
        if (isset($instance['iframe_height'])) {
            $iframe_height = $instance['iframe_height'];
        } else {
            $iframe_height = __('850', 'executive_widget_domain');
        }
        if (isset($instance['iframe_width'])) {
            $iframe_width = $instance['iframe_width'];
        } else {
            $iframe_width = __('800', 'executive_widget_domain');
        }

        // Widget admin form
        wp_enqueue_script('jscolor', plugins_url('/js/jscolor.js', __FILE__));
        ?>
        <p>
            <label for="<?php echo $this->get_field_id('font'); ?>"><?php _e('Font:'); ?></label>
            <select class='widefat' id="<?php echo $this->get_field_id('font'); ?>" name="<?php echo $this->get_field_name('font'); ?>" type="text">

                <option <?php
                if ($font == 'Source Sans Pro') {
                    echo 'selected="selected"';
                }
                ?> value="Source Sans Pro">Source Sans Pro</option>
                <option <?php
                if ($font == 'Open Sans') {
                    echo 'selected="selected"';
                }
                ?> value="Open Sans">Open Sans</option>
                <option <?php
                if ($font == 'Roboto') {
                    echo 'selected="selected"';
                }
                ?> value="Roboto">Roboto</option>
                <option <?php
                if ($font == 'Roboto Condensed') {
                    echo 'selected="selected"';
                }
                ?> value="Roboto Condensed">Roboto Condensed</option>
                <option <?php
                if ($font == 'Lato') {
                    echo 'selected="selected"';
                }
                ?> value="Lato">Lato</option>
                <option <?php
                if ($font == 'Oswald') {
                    echo 'selected="selected"';
                }
                ?> value="Oswald">Oswald</option>
                <option <?php
                if ($font == 'Raleway') {
                    echo 'selected="selected"';
                }
                ?> value="Raleway">Raleway</option>    
                <option <?php
                if ($font == 'Source Serif Pro') {
                    echo 'selected="selected"';
                }
                ?> value="Source Serif Pro">Source Serif Pro</option>    
                <option <?php
                if ($font == 'Alegreya') {
                    echo 'selected="selected"';
                }
                ?> value="Alegreya">Alegreya</option>    
                <option <?php
                if ($font == 'Neuton') {
                    echo 'selected="selected"';
                }
                ?> value="Neuton">Neuton</option>    
                <option <?php
                if ($font == 'Halant') {
                    echo 'selected="selected"';
                }
                ?> value="Halant">Halant</option>    
            </select>
            <br /><br />
            <label for="<?php echo $this->get_field_id('header_text_color'); ?>"><?php _e('Header Text Color:'); ?></label>
            <input class="widefat jscolor header_text_color" id="<?php echo $this->get_field_id('header_text_color'); ?>" name="<?php echo $this->get_field_name('header_text_color'); ?>" type="text" value="<?php echo esc_attr($header_text_color); ?>" />
            <br /><br />
            <label for="<?php echo $this->get_field_id('schedular_text_color'); ?>"><?php _e('Schedular Text Color'); ?></label>
            <input class="widefat jscolor schedular_text_color" id="<?php echo $this->get_field_id('schedular_text_color'); ?>" name="<?php echo $this->get_field_name('schedular_text_color'); ?>" type="text" value="<?php echo esc_attr($schedular_text_color); ?>" />
            <br /><br />
            <label for="<?php echo $this->get_field_id('body_background'); ?>"><?php _e('Body Background'); ?></label>
            <input class="widefat jscolor body_background" id="<?php echo $this->get_field_id('body_background'); ?>" name="<?php echo $this->get_field_name('body_background'); ?>" type="text" value="<?php echo esc_attr($body_background); ?>" />
            <br /><br />
            <label for="<?php echo $this->get_field_id('schedular_background'); ?>"><?php _e('Schedular Background'); ?></label>
            <input class="widefat jscolor schedular_background" id="<?php echo $this->get_field_id('schedular_background'); ?>" name="<?php echo $this->get_field_name('schedular_background'); ?>" type="text" value="<?php echo esc_attr($schedular_background); ?>" />
            <br /><br />
            <label for="<?php echo $this->get_field_id('star_background'); ?>"><?php _e('Star Background'); ?></label>
            <input class="widefat jscolor star_background" id="<?php echo $this->get_field_id('star_background'); ?>" name="<?php echo $this->get_field_name('star_background'); ?>" type="text" value="<?php echo esc_attr($star_background); ?>" />
            <br /><br />
            <label for="<?php echo $this->get_field_id('iframe_height'); ?>"><?php _e('iframe Height'); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('iframe_height'); ?>" name="<?php echo $this->get_field_name('iframe_height'); ?>" type="text" value="<?php echo esc_attr($iframe_height); ?>" />
            <br /><br />
            <label for="<?php echo $this->get_field_id('iframe_width'); ?>"><?php _e('iframe Width'); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('iframe_width'); ?>" name="<?php echo $this->get_field_name('iframe_width'); ?>" type="text" value="<?php echo esc_attr($iframe_width); ?>" />
        </p>
        <?php
    }

    // Updating widget replacing old instances with new
    public function update($new_instance, $old_instance) {
        $instance = array();
        $instance['font'] = (!empty($new_instance['font']) ) ? strip_tags($new_instance['font']) : '';
        $instance['header_text_color'] = (!empty($new_instance['header_text_color']) ) ? strip_tags($new_instance['header_text_color']) : '';
        $instance['schedular_text_color'] = (!empty($new_instance['schedular_text_color']) ) ? strip_tags($new_instance['schedular_text_color']) : '';
        $instance['body_background'] = (!empty($new_instance['body_background']) ) ? strip_tags($new_instance['body_background']) : '';
        $instance['schedular_background'] = (!empty($new_instance['schedular_background']) ) ? strip_tags($new_instance['schedular_background']) : '';
        $instance['star_background'] = (!empty($new_instance['star_background']) ) ? strip_tags($new_instance['star_background']) : '';
        $instance['source_name'] = (!empty($new_instance['source_name']) ) ? strip_tags($new_instance['source_name']) : '';
        $instance['iframe_height'] = (!empty($new_instance['iframe_height']) ) ? strip_tags($new_instance['iframe_height']) : 850;
        $instance['iframe_width'] = (!empty($new_instance['iframe_width']) ) ? strip_tags($new_instance['iframe_width']) : 800;
        return $instance;
    }

}


function json_response($url) {
    $raw = file_get_contents($url, 0, null, null);
    $decoded = json_decode($raw);
    return $decoded;
}

add_action('admin_footer', 'grw_admin_footer');

function grw_admin_footer() {
    ?>
    <script>         jQuery(document).on('widget-updated', function(e, widget) {
            location.reload();
        });
        jQuery(document).on('widget-added', function(e, widget) {
            var cusid_ele = document.getElementsByClassName('jscolor');
            for (var i = 0; i < cusid_ele.length; ++i) {
                var item = cusid_ele[i];
                var header_text_color = item.classList.contains('header_text_color');
                   if(header_text_color === true)
						{
							 var picker = new jscolor(item)
                            picker.fromString('68ac3c')
						}
				  var schedular_text_color = item.classList.contains('schedular_text_color');
                   if(schedular_text_color === true)
						{
							 var picker = new jscolor(item)
                            picker.fromString('475881')
						}
						
			  var body_background = item.classList.contains('body_background');
                   if(body_background === true)
						{
							 var picker = new jscolor(item)
                            picker.fromString('ffffff')
						}
						
			var schedular_background = item.classList.contains('schedular_background');
                   if(schedular_background === true)
						{
							 var picker = new jscolor(item)
                            picker.fromString('878383')
						}
						
			var star_background = item.classList.contains('star_background');
                   if(star_background === true)
						{
							 var picker = new jscolor(item)
                            picker.fromString('415E81')
						}											

                
            }
        });
    </script>
    <?php
}
?>